// HSampleHModel.h : interface of the HSampleHModel.cpp class, derived from HBaseModel
// Adds application-specific data and members for each model

#ifndef _HSampleHModel_H
#define _HSampleHModel_H

#include "HBaseModel.h"
#include "stdafx.h"
#include "parasolid_kernel.h"
#include "kernel_interface.h"
#include "hp_bridge.h"

class HSampleHModel : public HBaseModel
{
private:
	PK_PARTITION_t m_partition;

public:
	HSampleHModel();
	~HSampleHModel();

	virtual void Init();	
	virtual void Flush();
	PK_PARTITION_t GetPartition() { return m_partition; };
	HFileInputResult Read(LPCTSTR FileName);
	void CreateBlock(const double in_dX, const double in_dY, const double in_dZ, const double in_dOX, const double in_dOY, const double in_dOZ);
	void BlendEdgeR(PK_EDGE_t edge, double blendR);
	void DeleteEntity(PK_ENTITY_t entity);
	bool Boolean(PK_boolean_function_t operation, PK_BODY_t target, int number_of_tools, PK_BODY_t *tools);
	HFileOutputResult Write(const wchar_t * FileName);

private:
	const double m_dUnit = 1000.0;
};

#endif




